﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using Mono.Cecil;
using Mono.Cecil.Cil;
using Mono.Cecil.Mixin.Impl;
using NLog;
using NuGet;
using Torch.Loader.Plugins.Framework;
using Torch.Loader.Plugins.Patching;

namespace Torch.Loader.Utils
{
    public class PatchedPackageBuilder
    {
        private static readonly Logger _log = LogManager.GetCurrentClassLogger();

        public FrameworkContext Framework { get; }

        private readonly Dictionary<FrameworkAssembly, ModuleDefinition> _loadedModules =
            new Dictionary<FrameworkAssembly, ModuleDefinition>();

        private IAssemblyResolver _resolver;

        public PatchedPackageBuilder(FrameworkContext ctx)
        {
            Framework = ctx;
        }

        public void Load()
        {
            #region Setup Resolver

            {
                var resolver = new DefaultAssemblyResolver();
                var tmp = new HashSet<string>();
                foreach (var asm in Framework.Assemblies)
                    tmp.Add(Path.GetDirectoryName(asm.FullPath));
                foreach (var path in tmp)
                    resolver.AddSearchDirectory(path);
                _resolver = resolver;
            }

            #endregion

            #region Load Modules

            {
                _loadedModules.Clear();
                _transformersUsed.Clear();
                var readerParams = new ReaderParameters() {AssemblyResolver = _resolver};
                foreach (var asm in Framework.Assemblies)
                {
                    if (!asm.AllowPatching)
                        continue;

                    // do not dispose this stream, cecil does it for us
                    var module = ModuleDefinition.ReadModule(asm.GetStream(), readerParams);
                    _loadedModules.Add(asm, module);
                }
            }

            #endregion
        }

        private readonly List<string> _transformersUsed = new List<string>();

        public void Transform(IList<IAssemblyTransformer> transformers)
        {
            foreach (var t in transformers)
            {
                _transformersUsed.Add(t.GetType().FullName);
                foreach (var module in _loadedModules.Values)
                    t.TransformEarly(module);
            }

            for (var i = transformers.Count - 1; i >= 0; i--)
                foreach (var module in _loadedModules.Values)
                    transformers[i].TransformLate(module);
        }

        public void Mixin(IEnumerable<IPackageFile> files)
        {
            var mixinSelect = files.Where(x => x.IsMixin()).Select(file => ModuleDefinition.ReadModule(file.GetStream())).ToArray();
            if (mixinSelect.Length == 0)
                return;
            var context = new MixinManager();
            foreach (var k in _loadedModules.Values)
                context.AddTargetModule(k);
            foreach (var k in mixinSelect)
                context.AddMixinModule(k);
            context.Commit();
        }

        private PackageBuilder _builder;

        public void BeginBuilding()
        {
            _builder = new PackageBuilder
            {
                Id = Framework.Name,
                Version = Framework.Version,
                Description =
                    $"Patched by {_transformersUsed.Count} transformers.  {string.Join(", ", _transformersUsed)}"
            };
            _builder.Authors.Add($"Generated by {Framework.Provider.FullName}");
        }

        public void AddFile(string path, string content)
        {
            _builder.Files.Add(new MockPackageFile(content) {Path = path});
        }

        public void AddModules()
        {
            var writer = new WriterParameters()
            {
                // SymbolWriterProvider = new AutoSymbolWriterProvider() this would be useful if we can figure it out
            };
            foreach (var asm in Framework.Assemblies)
            {
                if (asm.Mode == FrameworkAssembly.AssemblyMode.Native)
                {
                    var path = Path.Combine("lib",
                        "native", // ReSharper disable once AssignNullToNotNullAttribute
                        Path.GetFileName(asm.RelativePath));
                    _builder.Files.Add(new MockPackageFile(() => asm.GetStream())
                    {
                        Path = path
                    });
                }
                else
                {
                    var path = Path.Combine("lib",
                        VersionUtility.GetShortFrameworkName(Extensions.CurrentFramework),
                        // ReSharper disable once AssignNullToNotNullAttribute
                        Path.GetFileName(asm.RelativePath));
                    MockPackageFile file;
                    if (_loadedModules.TryGetValue(asm, out var module))
                    {
                        using (var dest = new MemoryStream())
                        {
                            module.Write(dest, writer);
                            file = new MockPackageFile(dest.ToArray());
                        }
                    }
                    else
                        file = new MockPackageFile(() => asm.GetStream());

                    file.Path = path;
                    _builder.Files.Add(file);
                }
            }

            _builder.DependencySets.Add(new PackageDependencySet(null, Framework.Dependencies));
        }

        public void FinishBuilding()
        {
            var managedBinaries = new HashSet<string>();
            var nativeBinaries = new HashSet<string>();
            foreach (var file in _builder.Files)
            {
                if (!file.IsBinaryFile())
                    continue;
                if (file.Path.StartsWith("lib/native", StringComparison.OrdinalIgnoreCase) ||
                    file.Path.StartsWith("lib\\native", StringComparison.OrdinalIgnoreCase))
                    nativeBinaries.Add(file.Path);
                else if (file.Path.StartsWith("lib/", StringComparison.OrdinalIgnoreCase) ||
                         file.Path.StartsWith("lib\\", StringComparison.OrdinalIgnoreCase))
                    managedBinaries.Add(Path.GetFileName(file.Path));
            }

            _builder.PackageAssemblyReferences.Add(
                new PackageReferenceSet(Extensions.CurrentFramework, managedBinaries));
            if (nativeBinaries.Count > 0)
                AddFile(Path.Combine("build", _builder.Id + ".targets"), CopyNativeTargets("..\\", nativeBinaries));
        }

        public void Save(Stream output)
        {
            _builder.Save(output);
        }

        public void Save(IPackageRepository repo)
        {
            var packagePath = _builder.Id + "." + _builder.Version + NuGet.Constants.PackageExtension;
            var mock = new MockFileSystem();
            mock.AddFile(packagePath, _builder.Save);

            var temp = new OptimizedZipPackage(mock, packagePath);
            repo.AddPackage(temp);
        }

        private static string CopyNativeTargets(string pathToRoot, IEnumerable<string> files)
        {
            var sb = new StringBuilder();
            sb.AppendLine(
                "<Project ToolsVersion=\"4.0\" xmlns=\"http://schemas.microsoft.com/developer/msbuild/2003\">");
            sb.AppendLine("  <ItemGroup>");
            foreach (var f in files)
                sb.AppendLine(
                    $"    <ReferenceCopyLocalPaths Include=\"$(MSBuildThisFileDirectory){pathToRoot}\\{f}\" />");
            sb.AppendLine("  </ItemGroup>");
            sb.AppendLine("</Project>");
            return sb.ToString();
        }

        private class AutoSymbolWriterProvider : ISymbolWriterProvider
        {
            private readonly ISymbolWriterProvider _root = new DefaultSymbolWriterProvider();

            public ISymbolWriter GetSymbolWriter(ModuleDefinition module, string fileName)
            {
                return module.SymbolReader != null ? _root.GetSymbolWriter(module, fileName) : Auto(module);
            }

            public ISymbolWriter GetSymbolWriter(ModuleDefinition module, Stream symbolStream)
            {
                return module.SymbolReader != null ? _root.GetSymbolWriter(module, symbolStream) : Auto(module);
            }

            private ISymbolWriter Auto(ModuleDefinition module) => !module.HasDebugHeader || !module.GetDebugHeader().HasEntries ? new GenSymbolWriter(module) : null;

            private class GenSymbolWriter : ISymbolWriter
            {
                private readonly ImageDebugHeader _header;

                public GenSymbolWriter(ModuleDefinition module)
                {
                    byte[] codeViewHeader;
                    using (var raw = new MemoryStream())
                    using (var wrt = new BinaryWriter(raw))
                    {
                        wrt.Write((byte) 'S');
                        wrt.Write((byte) 'D');
                        wrt.Write((byte) 'S');
                        wrt.Write((byte) 'R');
                        var g = Guid.NewGuid();
                        wrt.Write(g.ToByteArray());
                        wrt.Write(42);
                        foreach (var c in module.Name)
                            wrt.Write((byte) c);
                        wrt.Write((byte) 0);
                        codeViewHeader = raw.ToArray();
                    }

                    var debugHeader = new ImageDebugHeaderEntry(new ImageDebugDirectory()
                    {
                        Type = ImageDebugType.CodeView,
                        MajorVersion = 0,
                        MinorVersion = 0,
                        SizeOfData = codeViewHeader.Length,
                        TimeDateStamp = (int) (DateTime.UtcNow.ToFileTime() / 1000L),
                        Characteristics = 0,
                        PointerToRawData = 0
                    }, codeViewHeader);
                    _header = new ImageDebugHeader(debugHeader);
                }

                public void Dispose()
                {
                }

                public ISymbolReaderProvider GetReaderProvider()
                {
                    return null;
                }

                public ImageDebugHeader GetDebugHeader()
                {
                    return _header;
                }

                public void Write(MethodDebugInformation info)
                {
                }
            }
        }
    }
}